-- Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.
--
-- Version 2 of the Resource Manager schema. The base schema;
-- modifications are made via separate pieces of migration code.
-- There is no version 1, we start with version 2 to match
-- corresponding mysql version.

-- The schema version, should be checked by the server during startup
CREATE TABLE RMAN_SCHEMA_VERSION (
  VERSION INTEGER NOT NULL
);

-- Update this value when the schema changes, also during migration
insert into RMAN_SCHEMA_VERSION values (2);

CREATE SEQUENCE RMAN_USERGROUPHISTORY_SEQ;
CREATE TABLE RMAN_USERGROUPHISTORY (
  ID BIGINT NOT NULL DEFAULT NEXTVAL('RMAN_USERGROUPHISTORY_SEQ'),
  USER_ VARCHAR(64) NOT NULL,
  GROUP_ VARCHAR(64) NOT NULL,
  SAMPLE_DATE BIGINT NOT NULL,
  FILE_COUNT BIGINT NOT NULL,
  BYTES BIGINT NOT NULL,
  RAW_BYTES BIGINT NOT NULL,
  PRIMARY KEY (ID)
);

CREATE SEQUENCE RMAN_WATCHEDDIR_SEQ;
CREATE TABLE RMAN_WATCHEDDIR (
  ID INT NOT NULL DEFAULT NEXTVAL('RMAN_WATCHEDDIR_SEQ'),
  PATH VARCHAR(255) NOT NULL,
  HDFSNAME VARCHAR(255) NOT NULL,
  PRIMARY KEY (ID)
);

CREATE SEQUENCE RMAN_WATCHEDDIRHISTORY_SEQ;
CREATE TABLE RMAN_WATCHEDDIRHISTORY (
  ID INT NOT NULL DEFAULT NEXTVAL('RMAN_WATCHEDDIRHISTORY_SEQ'),
  WATCHEDDIRECTORY_ID INT NOT NULL,
  USER_ VARCHAR(64) DEFAULT NULL,
  GROUP_ VARCHAR(64) DEFAULT NULL,
  SAMPLE_DATE BIGINT NOT NULL,
  FILE_COUNT BIGINT DEFAULT NULL,
  BYTES BIGINT DEFAULT NULL,
  RAW_BYTES BIGINT DEFAULT NULL,
  ATIME TIMESTAMP DEFAULT NULL,
  PRIMARY KEY (ID)
);
