// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
  "cloudera/cmf/page/ServiceConfig",
  "cloudera/cmf/page/ConfigNavTree",
  "cloudera/cmf/page/ConfigSearch",
  "cloudera/cmf/page/ConfigFilter",
  "cloudera/layout/AutoOverFlow2",
  "cloudera/AutoExpand"
], function(ServiceConfig, ConfigNavTree, ConfigSearch, ConfigFilter, AutoOverFlow2, AutoExpand) {

  return function(options) {

    // When this is turned on,
    // table resizing in response to browser resizing becomes
    // really really slow
    // $("#configTableBase").FixedTableHeader();

    var serviceConfigOptions = options.serviceConfigOptions;
    if (serviceConfigOptions.isAdmin) {
      var serviceConfig = new ServiceConfig(serviceConfigOptions);
    }

    var autoOverFlowOptions = options.autoOverFlowOptions;
    $("#cmfConfigLeftBarContent").AutoOverFlow2(autoOverFlowOptions);
    $("#cmfConfig").AutoOverFlow2(autoOverFlowOptions);

    $.subscribe("toggle", function ($elem) {
      if ($elem.hasClass('aboveConfigTable')) {
        $("#cmfConfigLeftBarContent").AutoOverFlow2("forceResize");
        $("#cmfConfig").AutoOverFlow2("forceResize");
      }
    });

    // Handles filter change.
    $("#filterByParamContext").change(function(evt){
      window.location.href = "?context=" + $(this).prop("value");
    });

    $('#annotation').autoExpand();

    var filter = new ConfigFilter();
    var navTree = new ConfigNavTree(options);
    var search = new ConfigSearch(options);

    return {};
  };

});
